import type { LoadContext } from "@docusaurus/types";
/**
 * The plugin's options.
 */
export interface RemoteContentPluginOptions {
    /**
     * Delete local content after everything?
     */
    performCleanup?: boolean;
    /**
     * CLI only mode
     */
    noRuntimeDownloads?: boolean;
    /**
     * Is this instance for the docs plugin?
     */
    docsIntegration?: boolean;
    /**
     * Is this instance for the blog plugin?
     */
    blogIntegration?: boolean;
    /**
     * The base url for the source of the content.
     */
    sourceBaseUrl: string;
    /**
     * Specify the document paths from the sourceBaseUrl
     * in a string array or function that returns a string array.
     */
    documents?: string[] | (() => string[]);
}
export declare type LoadableContent = void;
export default function pluginRemoteContent(context: LoadContext, options: RemoteContentPluginOptions): any;
//# sourceMappingURL=index.d.ts.map