"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var fs_1 = require("fs");
var path_1 = require("path");
var rimraf_1 = require("rimraf");
var chalk_1 = __importDefault(require("chalk"));
var pretty_ms_1 = __importDefault(require("pretty-ms"));
function pluginRemoteContent(context, options) {
    var blogIntegration = options.blogIntegration, docsIntegration = options.docsIntegration, sourceBaseUrl = options.sourceBaseUrl, documents = options.documents, noRuntimeDownloads = options.noRuntimeDownloads, performCleanup = options.performCleanup;
    if (![blogIntegration, docsIntegration].includes(true)) {
        throw new Error("No integrations enabled! Please enable either the blogIntegration or docsIntegration fields in your remote-content plugin options.");
    }
    if (documents === undefined) {
        throw new Error("The documents field is undefined, so I don't know what to fetch!");
    }
    if (sourceBaseUrl === undefined) {
        throw new Error("The sourceBaseUrl field is undefined, so I don't know where to fetch from!");
    }
    if (!sourceBaseUrl.endsWith("/")) {
        sourceBaseUrl = sourceBaseUrl + "/";
    }
    function findCollectables() {
        var a = [];
        if (docsIntegration === true || blogIntegration === true) {
            ;
            (typeof documents == "function"
                ? documents.call(context.siteConfig)
                : documents).forEach(function (d) {
                if (d.endsWith("md")) {
                    a.push({ url: sourceBaseUrl + "/" + d, identifier: d });
                }
                else {
                    a.push({ url: sourceBaseUrl + "/" + d + ".md", identifier: d + ".md" });
                }
            });
        }
        return a;
    }
    function getTargetDirectory() {
        if (docsIntegration) {
            return path_1.join(context.siteDir, "docs");
        }
        if (blogIntegration) {
            return path_1.join(context.siteDir, "blog");
        }
        return "";
    }
    // 'this' is a huge mess in JS, so we avoid that where we can, such as here.
    var pluginReturn = {
        name: "docusaurus-plugin-remote-content-" + [blogIntegration && "blog", docsIntegration && "docs"].filter(Boolean)[0],
        loadContent: function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (![false, undefined].includes(noRuntimeDownloads)) return [3 /*break*/, 2];
                            return [4 /*yield*/, pluginReturn.fetchContent()];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [2 /*return*/];
                    }
                });
            });
        },
        postBuild: function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(performCleanup !== false)) return [3 /*break*/, 2];
                            return [4 /*yield*/, pluginReturn.cleanContent()];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [2 /*return*/];
                    }
                });
            });
        },
        fetchContent: function () {
            return __awaiter(this, void 0, void 0, function () {
                var c, i, _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            c = findCollectables();
                            i = 0;
                            _c.label = 1;
                        case 1:
                            if (!(i < c.length)) return [3 /*break*/, 5];
                            _a = fs_1.writeFileSync;
                            _b = [path_1.join(getTargetDirectory(), c[i].identifier)];
                            return [4 /*yield*/, axios_1.default({ url: c[i].url })];
                        case 2: return [4 /*yield*/, (_c.sent()).data];
                        case 3:
                            _a.apply(void 0, _b.concat([_c.sent()]));
                            _c.label = 4;
                        case 4:
                            i++;
                            return [3 /*break*/, 1];
                        case 5: return [2 /*return*/];
                    }
                });
            });
        },
        cleanContent: function () {
            return __awaiter(this, void 0, void 0, function () {
                var c, i;
                return __generator(this, function (_a) {
                    c = findCollectables();
                    for (i = 0; i < c.length; i++) {
                        rimraf_1.sync(path_1.join(getTargetDirectory(), c[i].identifier));
                    }
                    return [2 /*return*/];
                });
            });
        },
        extendCli: function (cli) {
            var _this = this;
            var t = [blogIntegration && "blog", docsIntegration && "docs"].filter(Boolean)[0];
            cli
                .command("download-remote-" + t)
                .description("Downloads the remote " + t + " data.")
                .action(function () {
                ;
                (function () { return __awaiter(_this, void 0, void 0, function () {
                    var startTime;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                startTime = new Date();
                                return [4 /*yield*/, pluginReturn.fetchContent()];
                            case 1:
                                _a.sent();
                                console.log(chalk_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["{green Successfully fetched content in} {white ", "}{green !}"], ["{green Successfully fetched content in} {white ",
                                    "}{green !}"])), pretty_ms_1.default(new Date() - startTime)));
                                return [2 /*return*/];
                        }
                    });
                }); })();
            });
            cli
                .command("clear-remote-" + t)
                .description("Removes the local copy of the remote " + t + " data.")
                .action(function () {
                ;
                (function () { return __awaiter(_this, void 0, void 0, function () {
                    var startTime;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                startTime = new Date();
                                return [4 /*yield*/, pluginReturn.cleanContent()];
                            case 1:
                                _a.sent();
                                console.log(chalk_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["{green Successfully deleted content in} {white ", "}{green !}"], ["{green Successfully deleted content in} {white ",
                                    "}{green !}"])), pretty_ms_1.default(new Date() - startTime)));
                                return [2 /*return*/];
                        }
                    });
                }); })();
            });
        },
    };
    return pluginReturn;
}
exports.default = pluginRemoteContent;
var templateObject_1, templateObject_2;
//# sourceMappingURL=index.js.map